//
//  View.swift
//  Rotate
//
//  Created by Mark Meretzky on 11/20/14.
//  Copyright (c) 2014 Mark Meretzky. All rights reserved.
//

import UIKit;
import GLKit;	//needed for GLKMathDegreesToRadians

class View: UIView {
	let imageView: UIImageView;

	required init(coder aDecoder: NSCoder) {
		var image: UIImage? = UIImage(named: "assad.png");
		if image == nil {
			println("could not open assad.png");
			image = UIImage();	//Make a dummy image because the show must go on.
		}

		imageView = UIImageView(image: image!);
		super.init(coder: aDecoder);
		backgroundColor = UIColor.whiteColor();
		addSubview(imageView);

		let recognizer: UIRotationGestureRecognizer =
			UIRotationGestureRecognizer(target: self, action: "rotate:");
		addGestureRecognizer(recognizer);
	}

	//Called when a rotation gesture has been detected.

	func rotate(recognizer: UIRotationGestureRecognizer) {
		//Convert CGFloat to Float, because GLKMathRadiansToDegrees demands a Float parameter.
		let radians: Float = Float(recognizer.rotation);
		let degrees: Float = GLKMathRadiansToDegrees(radians);
		println("recognizer.rotation = \(degrees)");	//positive is clockwise

		imageView.transform = CGAffineTransformMakeRotation(recognizer.rotation);
	}

	/*
	Called whenever the size or shape of this View changes (e.g., when this View
	is first created, or when the orientation of the device changes).
	Re-center the UIImageView in this View.
	*/

	override func layoutSubviews() {
		imageView.center = center;
	}

	/*
	// Only override drawRect: if you perform custom drawing.
	// An empty implementation adversely affects performance during animation.
	override func drawRect(rect: CGRect) {
		// Drawing code
	}
	*/

}
